clc; clear; close all;
format compact;

dev_opt = 3;   % determines countries to include in sample
     hh = 4;   % number of portfolios for the dollar and euro 

cd C:\Users\   % path

f = importdata('1MF_EOP_Oct1983_Dec2015_datastream_prc_risk.csv');  f = f.data;  dtst = f(1:end,1);   f = f(:,2:end);
s = importdata('ER_EOP_Oct1983_Dec2015_datastream_prc_risk.csv');   s = s.data;  dtvc = s(1:end,1);   s = s(:,2:end); 

bg = 1994;                                      % begining date
[~,bg] = min(abs(dtvc-bg));                     
en = 2016;         [~,en] = min(abs(dtvc-en));  % end date Dec 31 2015

    s = s(bg:en,:);  
    f = f(bg:en,:);    
 dtvc = dtvc(bg+1:en,1); 
 dtst = dtst(bg+1:en,1);
    i = nan(size(f));
 
 for ti = 1:size(i,1)
     for ni = 1:size(i,2)
         if isnan(f(ti,ni)) ~= 1
             i(ti,ni) = log(f(ti,ni)) - log(s(ti,ni));         
         end
     end
 end
    i = i(1:end-1,:);
 eu_i = i - repmat(i(:,10),[1 size(i,2)]); %% euro forward discounts
  
[t,n] = size(s);
    s = log(s); ds = s(2:end,:) - s(1:end-1,:); ds = ds*1200;

 nms = ['AUS';'AUT';'BEL';'BRZ';'CAN';'CHL';'COL';'CZE';'DEN';'EUR';'FIN';'FRA';'GER';'GRE';'HUN';'ICE';'IND';'IRE';'ISR';'ITA';'JAP';'KOR';'MEX';'NET';'NOR';'NZL';'PHI';'POL';'POR';'ROM';'SAF';'SIN';'SPA';'SWE';'SWI';'TAI';'THA';'TUR';'UKP';'USD'];

 if dev_opt == 1
 dev = ['AUS';'AUT';'BEL';'CAN';'DEN';'EUR';'FIN';'FRA';'GER';'GRE';'ICE';'IRE';'ISR';'ITA';'JAP';'KOR';'NET';'NOR';'NZL';'POR';'SIN';'SPA';'SWE';'SWI';'TAI';'UKP';'USD'];

 elseif dev_opt == 2
 dev = ['AUS';'AUT';'BEL';'CAN';'DEN';'EUR';'FIN';'FRA';'GER';'GRE';'IRE';'ITA';'JAP';'NET';'NOR';'NZL';'POR';'SPA';'SWE';'SWI';'UKP';'USD'];
 
 elseif dev_opt == 3
 dev = ['AUS';'CAN';'EUR';'GER';'JAP';'NOR';'NZL';'SWE';'SWI';'UKP';'USD'];
 
 else
 dev = nms;
 end
 
% make USD and EURO factors for each currency 
dusd = zeros(size(ds,1),size(ds,2)+1);
deur = zeros(size(ds,1),size(ds,2)+1);

 ind = (1:n)';indn = setdiff(ind,40);
dusd(:,end) = mean(ds(:,indn),2,'omitnan');

euro = s - repmat(s(:,10),[1 n]);
  de = 1200*(euro(2:end,:) - euro(1:end-1,:)); 
indn = setdiff(ind,10);
deur(:,end) = mean(de(:,indn),2,'omitnan');

for ni = 1:n
         indn = setdiff(ind,[ni;40]);
   dusd(:,ni) = mean(ds(:,indn),2,'omitnan');
         indn = setdiff(ind,[ni;10]);
   deur(:,ni) = mean(de(:,indn),2,'omitnan');
end

crpf = zeros(t-1,n+1);
crss = zeros(t-1,n+1,hh);
crmb = zeros(t-1,n);
indn = (1:n)';

VPFcoord = nan(t-1,n,2);

[~,smpp] = intersect(cellstr(nms),cellstr(dev));
 
  dr = - ds + i*1200;    % excess returns for foreign investors in US dollar
  er = - de + eu_i*1200; % excess returns for foreign investors in euro
  
    rr = 60;
[tt,~] = size(ds); 
   
ldng = nan(tt-rr,n,1);
upfV = zeros(tt-rr,hh,3); uVLS = -ones(size(upfV));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% euro and dollar betas
disp(' ');disp(' ');
disp('/////////////////////////////////////////////////////////////////////');
disp('GMSW: $ and euro portfolios and risk prices');
disp(' ');
ldng = nan(tt-rr,n,2);
uspf = zeros(tt-rr,hh,3);   usLS = -ones(size(uspf));
eupf = zeros(tt-rr,hh,3);   euLS = -ones(size(eupf));
PFcoord = nan(t-1,n,2);

for ti = 1:tt-rr
    
    for ni = 1:n        
        if isnan(i(ti+rr,ni)) ~= 1                  % must have forward and spot rates in period t+1 for the currency to be included
           if max(isnan(ds(ti:ti+rr,ni))) ~= 1      % must have rr observations of spot return data in order to run the regression
              
                ff = [dusd(ti:ti+rr-1,ni), deur(ti:ti+rr-1,ni), ones(rr,1)];  
                dy = ds(ti:ti+rr-1,ni);    
                b1 = inv(ff'*ff)*ff'*dy;    ldng(ti,ni,1) = b1(1); % dollar-beta
                                            ldng(ti,ni,2) = b1(2); % euro-beta                  
           end          
        end     
    end
    
     [sorted,ind0] = sortrows([ldng(ti,:,1)',isnan(ldng(ti,:,1)')],1);    
              ind0 = ind0(sorted(:,2)==0);    
                nn = size(ind0,1);
                
              [~,ind0] = sortrows(ldng(ti,:,1)',1);   
              
             nmbs = floor(nn/hh)*ones(hh,1);      rmdr = nn - hh*floor(nn/hh);   
            nmbs(1) =  nmbs(1)+floor(rmdr*0.5); nmbs(end) =  nmbs(end)+ceil(rmdr*0.5);
                 nh = cumsum(nmbs); nh = [1; nh+1];     
     
            
             for hi = 1:hh
                    uspf(ti,hi,1) = mean(dr(ti+rr,ind0(nh(hi):nh(hi+1)-1)),'omitnan');      % $ excess returns
                    uspf(ti,hi,2) = mean(ds(ti+rr,ind0(nh(hi):nh(hi+1)-1)),'omitnan');      % $ spot returns
                    uspf(ti,hi,3) = mean(1200*i(ti+rr,ind0(nh(hi):nh(hi+1)-1)),'omitnan');  % $ interest rate differentials
                    PFcoord(ti+rr,ind0(nh(hi):nh(hi+1)-1),1) = hi;
             end                         
           usLS(ti,:,:) = mean(i(ti+rr,smpp),'omitnan') > 0;      % record of whether ROW interest rate differential is positive
           
        [sorted,ind0] = sortrows([ldng(ti,:,2)',isnan(ldng(ti,:,2)')],1);    
                 ind0 = ind0(sorted(:,2)==0);
                                
                 nmbs = floor(nn/hh)*ones(hh,1);      rmdr = nn - hh*floor(nn/hh);           

           nmbs(1) =  nmbs(1)+floor(rmdr*0.5); nmbs(end) =  nmbs(end)+ceil(rmdr*0.5);
                nh = cumsum(nmbs); nh = [1; nh+1];
               
             for hi = 1:hh
                    eupf(ti,hi,1) = mean(er(ti+rr,ind0(nh(hi):nh(hi+1)-1)),'omitnan');          % euro excess returns
                    eupf(ti,hi,2) = mean(de(ti+rr,ind0(nh(hi):nh(hi+1)-1)),'omitnan');          % euro spot returns
                    eupf(ti,hi,3) = mean(1200*eu_i(ti+rr,ind0(nh(hi):nh(hi+1)-1)),'omitnan');   % euro interest rate differential
                    PFcoord(ti+rr,ind0(nh(hi):nh(hi+1)-1),2) = hi;
             end 
                           
            euLS(ti,:,:) = mean(eu_i(ti+rr,smpp),'omitnan') >0;  % record of whether ROW interest rate differential for euro is positive
end

 usLS(usLS==0) = -1;  % if ROW interest rate differential is negative, set to -1
 euLS(euLS==0) = -1;  % if ROW euro interest rate differential is negative, set to -1

 uspf = uspf.*usLS;  
 eupf = eupf.*euLS;  
 
disp(' ');
disp('GMSW dollar-beta sorted portfolios');
disp('left to right: lowest to highest betas');
disp('mean (first row) and standard deviation (second row) of excess returns');
disp(squeeze(mean(uspf(:,:,1))));
disp(squeeze(std(uspf(:,:,1))));
disp('mean (first row) and standard deviation (second row) of depreciation rates');
disp(squeeze(mean(uspf(:,:,2))));
disp(squeeze(std(uspf(:,:,2))));
disp('mean (first row) and standard deviation (second row) of interest rate differentials');
disp(squeeze(mean(uspf(:,:,3))));
disp(squeeze(std(uspf(:,:,3))));

disp(' ');
disp('GMSW euro-beta sorted portfolios');
disp('left to right: lowest to highest betas');
disp('mean (first row) and standard deviation (second row) of excess returns');
disp(squeeze(mean(eupf(:,:,1))));
disp(squeeze(std(eupf(:,:,1))));
disp('mean (first row) and standard deviation (second row) of depreciation rates');
disp(squeeze(mean(eupf(:,:,2))));
disp(squeeze(std(eupf(:,:,2))));
disp('mean (first row) and standard deviation (second row) of interest rate differentials');
disp(squeeze(mean(eupf(:,:,3))));
disp(squeeze(std(eupf(:,:,3)))); pause;

dollar_rsk = sum(uspf(:,:,1),2)/hh;
  euro_rsk = sum(eupf(:,:,1),2)/hh;   
  
        ff = [dollar_rsk, euro_rsk]; 
 
disp(' ');
disp('GMSW long-short dollar and euro portfolios mean excess return');
disp(mean(ff));
disp('GMSW long-short dollar and euro portfolios standard deviation');
disp(std(ff));
disp('GMSW long-short dollar and euro portfolios Sharpe Ratio');
disp(mean(ff)./std(ff));
figure;plot(dtvc(rr+1:end),cumsum(ff/1200));
pause;

 disp(' ');
 disp(' ');
  f = ff;
 Re = [uspf(:,:,1),eupf(:,:,1)];   
 [o1,o2,o3,o4,B] = BergMarkFMB(Re,f);
 disp('Berg-Mark GMM FMB: $ and euro risk factors; Returns on $ and euro PFs used in regressions');
 disp('Estimated Risk Premia (1st row) and robust t-statistics (2nd row)');
 disp([o1;o2]);
  disp('First stage betas: $ portfolios; $ factor (1st row), euro factor (2nd row)');
 disp(B(1:hh,:)');
 disp('First stage betas: euro portfolios; $ factor (1st row), euro factor (2nd row)');
 disp(B(hh+1:end,:)');
 disp('R-squared, chi-squared statistic on pricing errors, p-value on chi-squared');
 disp([o3,o4]);
